package hexagon.gui;

import hexagon.graphics.Shader;
import hexagon.model.Loader;
import hexagon.model.RawModel;

import java.util.List;

import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL13;
import org.lwjgl.opengl.GL20;
import org.lwjgl.opengl.GL30;

public class GuiRenderer {
	
	private final RawModel quad;
	
	public GuiRenderer() {
		float[] positions = { -1, 1, -1, -1, 1, 1, 1, -1 };
		quad = Loader.theLoader.loadToVAO(positions);
	}
	
	public void render(List<GuiTexture> guis) {
		Shader.gui.enable();
		GL30.glBindVertexArray(quad.getVaoID());
		GL20.glEnableVertexAttribArray(0);
		GL11.glEnable(GL11.GL_BLEND);
		GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
		GL11.glDisable(GL11.GL_DEPTH_TEST);
		for (GuiTexture gui : guis) {
			GL13.glActiveTexture(0);
			GL11.glBindTexture(GL11.GL_TEXTURE_2D, gui.getTexID());
			Shader.gui.setUniformMat4("transformationMatrix", gui.transfMatrix);
			GL11.glDrawArrays(GL11.GL_TRIANGLE_STRIP, 0, quad.getVertexCount());
		}
		GL11.glEnable(GL11.GL_DEPTH_TEST);
		GL11.glDisable(GL11.GL_BLEND);
		GL20.glDisableVertexAttribArray(0);
		GL30.glBindVertexArray(0);
	}
	
}
