package hexagon.world.entity;

import org.lwjgl.util.vector.Vector3f;

import hexagon.model.HexagonModel;
import hexagon.model.Loader;
import hexagon.util.CylVec3;
import hexagon.util.MathUtil;
import hexagon.util.Vec3f;
import hexagon.world.Block;
import hexagon.world.World;

public class Hexagon extends Entity {
	
	public static HexagonModel model;
	
	public Block block;
	
	public Hexagon(Block b, boolean upside) {
		super(null, new Vec3f(), new Vector3f(), 1f, (float) Math.pow(1 - 1 / World.radius, upside ? b.y + 1 : b.y));
		MathUtil.initHexagon(this, b.x, upside ? b.y + 1 : b.y, b.z);
//		this.y = -x - z;
		this.block = b;
	}
	
	public double distSq(float x, double rv) {
		CylVec3 pos = position.getCyl();
		float xx = x - pos.x;
		double zz = rv - pos.rv;
		if (zz < 0) zz += 2 * Math.PI * pos.r;
		return xx * xx + zz * zz;
	}
	
	public int getX() {
		return block.x;
	}
	
	public int getZ() {
		return block.z;
	}
	
//	private int distance(Hexagon hex) {
//		return Math.max(Math.max(Math.abs(x - hex.x), Math.abs(hex.y - y)), Math.abs(hex.z - z)) / 2;
//	}
	
	public static void init() {
		model = new HexagonModel(Loader.theLoader.loadTexture("test"));
	}
	
}
