package hexagon.util;

import org.lwjgl.input.Mouse;
import org.lwjgl.opengl.Display;
import org.lwjgl.util.vector.Matrix4f;
import org.lwjgl.util.vector.Vector3f;
import org.lwjgl.util.vector.Vector4f;

import hexagon.Camera;
import hexagon.Main;
import hexagon.world.Block;
import hexagon.world.World;

public class MousePicker {
	
	private Vector3f currentRay;
	
	private Matrix4f projectionMatrix;
	private Matrix4f viewMatrix;
	private Camera camera;
	
	public MousePicker(Camera camera) {
		this.camera = camera;
		this.projectionMatrix = camera.projectionMatrix;
		viewMatrix = camera.viewMatrix;
	}
	
	public Vector3f getCurrentRay() {
		return currentRay;
	}
	
	public void update() {
		currentRay = calculateMouseRay();
	}
	
	private Vector3f calculateMouseRay() {
		return toWorldCoords(toEyeCoords(new Vector4f(Mouse.getX() * 2f / Display.getWidth() - 1, Mouse.getY() * 2f / Display.getHeight() - 1, -1f, 1f)));
	}
	
	private Vector3f toWorldCoords(Vector4f eyeCoords) {
		Matrix4f invView = Matrix4f.invert(viewMatrix, null);
		Vector4f rayWorld = Matrix4f.transform(invView, eyeCoords, null);
		Vector3f mouseRay = new Vector3f(rayWorld.x, rayWorld.y, rayWorld.z);
		mouseRay.normalise();
		return mouseRay;
	}
	
	private Vector4f toEyeCoords(Vector4f clipCoords) {
		Matrix4f invProj = Matrix4f.invert(projectionMatrix, null);
		Vector4f eyeCoords = Matrix4f.transform(invProj, clipCoords, null);
		return new Vector4f(eyeCoords.x, eyeCoords.y, -1f, 0f);
	}
	
	public Block getBlockPointedAt(World world) {
		Camera cam = Main.main.camera;
		CylVec3 camPos = cam.position.getCyl();
		Vector3f current = new Vector3f((int) (camPos.x / 2), (int) (Math.log(camPos.r) / Math.log(1 - 1 / World.radius)), (int) (camPos.rv / camPos.r / World.angleHalfHexagon * 2));
		Vector3f[] points = new Vector3f[12];
		for (int i = 0; i < 12; i++) {
			
		}
		
		return null;
	}
	
}
