#version 330 core

in vec3 position;
in vec2 texCoords;
in vec3 colorTint;

out vec2 pass_texCoords;
out vec3 pass_colorTint;

uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;

void main() {
	gl_Position = projectionMatrix * viewMatrix * vec4(position, 1);
	pass_texCoords = texCoords;
	pass_colorTint = colorTint;
}