package hexagon.util;

import org.lwjgl.util.vector.Vector3f;

public class Vec3f {
	
	private Vector3f eucl, cyl;
	
	public Vec3f() {
		cyl = new Vector3f();
		eucl = new Vector3f();
	}
	
	public Vec3f(Vector3f vec, boolean isCyl) {
		if (isCyl) {
			cyl = vec;
			cylToEuclCoords(vec, eucl);
		} else {
			eucl = vec;
			euclToCylCoords(vec, cyl);
		}
	}
	
	public void setEucl(Vector3f src) {
		eucl.x = src.x;
		eucl.y = src.y;
		eucl.z = src.z;
		euclToCylCoords(eucl, cyl);
	}
	
	public void setEucl(float x, float y, float z) {
		eucl.x = x;
		eucl.y = y;
		eucl.z = z;
		euclToCylCoords(eucl, cyl);
	}
	
	public void setCyl(Vector3f src) {
		cyl.x = src.x;
		cyl.y = src.y;
		cyl.z = src.z;
		cylToEuclCoords(cyl, eucl);
	}
	
	public void setCyl(float x, float r, float v) {
		cyl.x = x;
		cyl.y = r;
		cyl.z = v;
		cylToEuclCoords(cyl, eucl);
	}
	
	public Vector3f getEucl() {
		return eucl;
	}
	
	public Vector3f getCyl() {
		return cyl;
	}
	
	public void updateEucl() {
		cyl.z %= Math.PI * 2;
		if (cyl.z < 0) cyl.z += Math.PI * 2;
		cylToEuclCoords(cyl, eucl);
	}
	
	public void updateCyl() {
		euclToCylCoords(eucl, cyl);
	}
	
	/** @param src where x = x, y = radius, z = angle */
	public static void cylToEuclCoords(Vector3f src, Vector3f dest) {
		dest.x = src.x;
		float yy = (float) (src.y * Math.sin(src.z));
		dest.z = (float) (src.y * Math.cos(src.z));
		dest.y = yy;
	}
	
	/** @param dest where x = x, y = radius, z = angle */
	public static void euclToCylCoords(Vector3f src, Vector3f dest) {
		dest.x = src.x;
		float yy = (float) Math.hypot(src.y, src.z);
		dest.z = (float) Math.atan2(src.y, src.z);
		dest.y = yy;
	}
	
}
