package hexagon.world;

import java.util.Arrays;

public class ChunkRing {
	/** Number of chunks in a ring */
	public static final int ringSize = 64;
	
	protected Chunk[] chunks = new Chunk[ringSize];
	
	public final int x;
	
	public ChunkRing(int x) {
		this.x = x;
	}
	
	public void onRemove() {
		for (Chunk c : chunks)
			if (c != null) c.onRemove();
		Arrays.fill(chunks, null);
	}
	
}
