package hexagon.world.entity;

import hexagon.model.TexturedModel;
import hexagon.util.MathUtil;
import hexagon.util.Vec3f;

import org.lwjgl.util.vector.Matrix4f;
import org.lwjgl.util.vector.Vector3f;

public class Entity {
	
	public TexturedModel model;
	public Vec3f position;
	public Vector3f rotation;
	public float scale;
	public Matrix4f transfMatrix;
	
	public Entity(TexturedModel model, Vec3f position, Vector3f rotation, float scale) {
		this.model = model;
		this.position = position;
		this.rotation = rotation;
		this.scale = scale;
		transfMatrix = new Matrix4f();
		updateTransfMatrix();
	}
	
	public void increasePosition(float dx, float dr, float dv) {
		Vector3f cyl = position.getCyl();
		cyl.x += dx;
		cyl.y += dr;
		cyl.z += dv;
		position.updateEucl();
		updateTransfMatrix();
	}
	
	public void increaseRotation(float dx, float dy, float dz) {
		rotation.x += dx;
		rotation.y += dy;
		rotation.z += dz;
		updateTransfMatrix();
	}
	
	public void updateTransfMatrix() {
		MathUtil.transformationMatrix(position.getEucl(), rotation, scale, transfMatrix);
	}
	
}
