package hexagon.world.entity;

import org.lwjgl.opengl.GL11;
import org.lwjgl.util.vector.Vector2f;
import org.lwjgl.util.vector.Vector3f;

import hexagon.Camera;
import hexagon.graphics.Renderer;
import hexagon.graphics.Shader;
import hexagon.model.HexagonModel;
import hexagon.model.Loader;
import hexagon.util.MathUtil;
import hexagon.util.Vec3f;
import hexagon.world.World;

public class Hexagon extends Entity {
	
	public static final Vector2f[] points = new Vector2f[6];
	public static HexagonModel model;
	
	public Vector3f colorTint;
	private int x, z; // x: --		z: \
	private boolean isSelected = false;
	
	private World world;
	
	public Hexagon(int x, int y, int z, Vector3f color, World world) {
		super(model, new Vec3f(), new Vector3f(), (float) Math.pow(0.95, y));
		MathUtil.initHexagon(this, x, y, z);
		this.x = x;
		this.z = z;
//		this.y = -x - z;
		this.world = world;
		this.colorTint = color;
	}
	
	public void onUpdate() {
		
	}
	
	public void onRemove() {
		
	}
	
	public float distSq(float x, float v) {
		Vector3f pos = position.getCyl();
		float xx = x - pos.x, zz = v - pos.z;
		if (zz < 0) zz += 2 * Math.PI;
		zz *= World.radius;
		return xx * xx + zz * zz;
	}
	
	public int getX() {
		return x;
	}
	
	public int getZ() {
		return z;
	}
	
	public boolean selected() {
		return isSelected;
	}
	
	public void select() {
		isSelected = true;
	}
	
	public void deSelect() {
		isSelected = false;
	}
	
//	private int distance(Hexagon hex) {
//		return Math.max(Math.max(Math.abs(x - hex.x), Math.abs(hex.y - y)), Math.abs(hex.z - z)) / 2;
//	}
	
	@Deprecated
	public void render(Renderer renderer, Camera camera) {
		System.out.println("Wrong render method!!!");
		if (isSelected) Shader.hexagon.setUniform1f("glow", 1.5f);
		Shader.hexagon.setUniform3f("colorTint", colorTint.x, colorTint.y, colorTint.z);
		Shader.hexagon.setUniformMat4("transformationMatrix", transfMatrix);
		
		GL11.glDrawElements(GL11.GL_TRIANGLES, model.getRawModel().getVertexCount(), GL11.GL_UNSIGNED_INT, 0);
		
		if (isSelected) Shader.hexagon.setUniform1f("glow", 1f);
	}
	
	public static void init() {
		for (int i = 0; i < 6; i++) {
			points[i] = new Vector2f((float) Math.cos(Math.PI * (i / 3d)), (float) Math.sin(Math.PI * (i / 3d)));
		}
		model = new HexagonModel(Loader.theLoader.loadTexture("test"));
	}
	
}
