package hexagon.world;

import org.lwjgl.util.vector.Vector3f;

import hexagon.graphics.HexagonRenderer;
import hexagon.world.entity.Hexagon;

public class Block {
	
	private int x, y, z;
	private World world;
	protected Hexagon up, down;
	protected BlockSide[] sides = new BlockSide[6];
	private byte sidesToRender = 0;
	
	public Block(int x, int y, int z, World world) {
		this.x = x;
		this.y = y;
		this.z = z;
		this.world = world;
		sidesToRender = 1;
		up = new Hexagon(x, y, z, new Vector3f(1f, 1f - (float) Math.random() * 0.5f, 1f), world);
		down = new Hexagon(x, y + 1, z, new Vector3f(1f, 1f - (float) Math.random() * 0.5f, 1f), world);
	}
	
	public void submit(HexagonRenderer renderer) {
		if ((sidesToRender & 1) != 0 && up != null) renderer.submit(up);
		if ((sidesToRender & 1 << 1) != 0 && down != null) renderer.submit(down);
		for (int i = 0; i < 6; i++) {
			if ((sidesToRender & 1 << i + 2) != 0 && sides[i] != null) {
				// render side
			}
		}
	}
	
	public void onRemove() {}
	public void onUpdate() {}
	
}
