package hexagon.world;

import java.util.Comparator;
import java.util.TreeMap;

public class BlockColumn {
	
	private int x, z, yTop;
	protected TreeMap<Integer, Block> blocks;
	private Chunk chunk;
	
	public BlockColumn(int x, int z, Chunk chunk) {
		this.x = x;
		this.z = z;
		this.chunk = chunk;
		yTop = 0;
		blocks = new TreeMap<>(Comparator.reverseOrder());
	}
	
	public void setBlock(Block block, int y) {
		Block prev = blocks.put(y, block);
		if (prev != null) prev.onRemove();
	}
	
	public Block getBlock(int y) {
		return blocks.get(y);
	}
	
	public void onRemove() {
		for (Block b : blocks.values())
			b.onRemove();
		blocks.clear();
	}
	
}
