package hexagon.world.entity;

import org.lwjgl.util.vector.Vector2f;
import org.lwjgl.util.vector.Vector3f;

import hexagon.model.HexagonModel;
import hexagon.model.Loader;
import hexagon.util.CylVec3;
import hexagon.util.MathUtil;
import hexagon.util.Vec3f;
import hexagon.world.World;

public class Hexagon extends Entity {
	
	public static final Vector2f[] points = new Vector2f[6];
	public static HexagonModel model;
	
	public Vector3f colorTint;
	private int x, z; // x: --		z: \
	private boolean isSelected = false;
	
	private World world;
	
	public Hexagon(int x, int y, int z, Vector3f color, World world) {
		super(model, new Vec3f(), new Vector3f(), 1f, (float) Math.pow(1 - 1 / World.radius, y));
		MathUtil.initHexagon(this, x, y, z);
		this.x = x;
		this.z = z;
//		this.y = -x - z;
		this.world = world;
		this.colorTint = color;
	}
	
	public void onUpdate() {
		
	}
	
	public void onRemove() {
		
	}
	
	public double distSq(float x, double rv) {
		CylVec3 pos = position.getCyl();
		float xx = x - pos.x;
		double zz = rv - pos.rv;
		if (zz < 0) zz += 2 * Math.PI * pos.r;
		return xx * xx + zz * zz;
	}
	
	public int getX() {
		return x;
	}
	
	public int getZ() {
		return z;
	}
	
	public boolean selected() {
		return isSelected;
	}
	
	public void select() {
		isSelected = true;
	}
	
	public void deSelect() {
		isSelected = false;
	}
	
//	private int distance(Hexagon hex) {
//		return Math.max(Math.max(Math.abs(x - hex.x), Math.abs(hex.y - y)), Math.abs(hex.z - z)) / 2;
//	}
	
	public static void init() {
		for (int i = 0; i < 6; i++) {
			points[i] = new Vector2f((float) Math.cos(Math.PI * (i / 3d)), (float) Math.sin(Math.PI * (i / 3d)));
		}
		model = new HexagonModel(Loader.theLoader.loadTexture("test"));
	}
	
}
