#version 330 core

in vec3 position;
in vec2 texCoords;
in vec3 colorTint;

out Data {
	vec2 texCoords;
	vec3 colorTint;
} pass;

uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;

void main() {
	gl_Position = projectionMatrix * viewMatrix * vec4(position, 1.0);
	pass.texCoords = texCoords;
	pass.colorTint = colorTint;
}