package hexagon.model;

import hexagon.world.World;
import hexagon.world.entity.Hexagon;

public class HexagonModel extends TexturedModel {
	
	public static final float y60 = Hexagon.points[1].y, x60 = Hexagon.points[1].x;
	
	public static float[] vertices = new float[3 * 6];
	public static float[] texCoords = new float[2 * 6];
	public static int[] indices = new int[3 * 4];
	
	public HexagonModel(int texID) {
		super(createRawModel(), texID);
	}
	
	private static RawModel createRawModel() {
		for (int i = 0; i < 6; i++) {
			double v = i % 3 == 0 ? 0 : (i > 3 ? -1 : 1) * World.angleHalfHexagon;
			vertices[3 * i] = Hexagon.points[i].x;
			vertices[3 * i + 1] = (float) ((Math.cos(v) - 1) * World.radius);
			vertices[3 * i + 2] = (float) (Math.sin(v) * World.radius);
		}
		
		for (int i = 0; i < 4; i++) {
			indices[3 * i] = 0;
			indices[3 * i + 1] = i + 1;
			indices[3 * i + 2] = i + 2;
		}
		
		for (int i = 0; i < 6; i++) {
			texCoords[2 * i] = Hexagon.points[i].x;
			texCoords[2 * i + 1] = Hexagon.points[i].y;
		}
		
		return Loader.theLoader.loadToVAO(vertices, texCoords, indices);
	}
	
	
}
