package hexagon.world;

import org.lwjgl.util.vector.Vector3f;

import hexagon.graphics.BlockRenderer;
import hexagon.world.entity.Hexagon;

public class Block {
	
	private final int x, y, z;
	public final BlockColumn blockColumn;
	public Hexagon up, down;
	protected BlockSide[] sides = new BlockSide[6];
	private byte sidesToRender = 0;
	
	public Block(int x, int y, int z, BlockColumn blockColumn) {
		this.x = x;
		this.y = y;
		this.z = z;
		this.blockColumn = blockColumn;
		sidesToRender = ~0;
		up = new Hexagon(x, y, z, new Vector3f(1f, 1f - (float) Math.random() * 0.5f, 1f), this);
		down = new Hexagon(x, y + 1, z, new Vector3f(1f, 1f - (float) Math.random() * 0.5f, 1f), this);
		for (int i = 0; i < 6; i++)
			sides[i] = new BlockSide(i, this);
	}
	
	public void submit() {
		if (sidesToRender == 0) return;
		
		if ((sidesToRender & 1) != 0 && up != null) BlockRenderer.hexagon.submit(up);
		if ((sidesToRender & 1 << 1) != 0 && down != null) BlockRenderer.hexagon.submit(down);
		for (int i = 0; i < 6; i++) {
			if ((sidesToRender & 1 << i + 2) != 0 && sides[i] != null) {
				BlockRenderer.blockSide.submit(sides[i]);
			}
		}
	}
	
	public void onRemove() {}
	
	public void onUpdate() {}
	
}
